CREATE OR REPLACE
PROCEDURE INTEGRACAO_PACIENTE
IS
   V_CDFILIAL         VARCHAR2(04) := '1345';
   V_EXIST            VARCHAR2(20);
   V_CDPACIENTE       VARCHAR2(12);
   V_CDLEITO          VARCHAR2(12);
   V_DTPRESDIET       PRESDIET.DTPRESDIET%TYPE;
   V_SYSDATE          PRESDIET.DTPRESDIET%TYPE;
   V_IDPACIENT        VARCHAR2(1) := '0';
   V_CONST_N          VARCHAR2(1) := 'N';
   V_CONST_S          VARCHAR2(1) := 'S';
   V_DTALTA           DATE;
   V_CDTABECDIPA      VARCHAR2(7);
   V_CDDIAGNOST       VARCHAR2(10);
   V_CDDIETPAD        VARCHAR2(4);
   v_QTCOMMIT         NUMBER;
     
BEGIN
   v_QTCOMMIT := 0;
  
   /*LOOP DE PACIENTES*/
        
   FOR C_PACIENTE IN(
       SELECT INTPES.CD_INTEGRA_SAIDA_CAD_PESSOA AS CD_INTEGRA_SAIDA_CAD_PESSOA,
              INTPES.CD_PESSOA AS CD_PESSOA,
              INTPES.NM_PESSOA AS NM_PESSOA,
              INTPES.DT_NASCIMENTO AS DT_NASCIMENTO,
              INTPES.TP_SEXO AS TP_SEXO
        FROM MVINTEGRA.INTEGRA_SAIDA_CAD_PESSOA@LNK_SAPORE_H9JULHO INTPES
        WHERE (INTPES.TP_CLIENTE_FORN = 'I')
          AND (INTPES.TP_INTEGRACAO = 'A')
          AND (INTPES.DT_INTEGRACAO > SYSDATE - 5)
          AND not EXISTS(SELECT STATUS.CD_INTEGRA_SAIDA_CAD_PESSOA
                         FROM MVINTEGRA.INTEGRA_SAIDA_CAD_PESSOA_STS@LNK_SAPORE_H9JULHO STATUS
                         WHERE (INTPES.CD_INTEGRA_SAIDA_CAD_PESSOA = STATUS.CD_INTEGRA_SAIDA_CAD_PESSOA)
                           AND (STATUS.DS_EMPRESA_INTEGRACAO = 'TEKNISA')
                           ))

   LOOP                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                

      /*VERIFICAR SE J EXISTE O PACIENTE CADASTRADO*/

      SELECT MAX(CDPACIENTE)
        INTO V_EXIST
        FROM PACIENTE
      WHERE (CDFILIAL = V_CDFILIAL)
        AND (CDPACIENTE = C_PACIENTE.CD_PESSOA);

      IF (V_EXIST IS NULL) THEN
         INSERT INTO PACIENTE (CDFILIAL, CDPACIENTE, NMPACIENTE, NMSOBRNOME,
                               IDSEXOPACI, DTNASCPACI, IDPACIENT, NMPACIUPPER)
                       VALUES (V_CDFILIAL, C_PACIENTE.CD_PESSOA, C_PACIENTE.NM_PESSOA,
                               SUBSTR(C_PACIENTE.NM_PESSOA, INSTR(C_PACIENTE.NM_PESSOA,' ',-1,1)+1,15),
                               DECODE(C_PACIENTE.TP_SEXO, 'M','0', DECODE(C_PACIENTE.TP_SEXO, 'F', '1','3')),
                               C_PACIENTE.DT_NASCIMENTO, V_IDPACIENT, UPPER(C_PACIENTE.NM_PESSOA));

         INSERT INTO MVINTEGRA.INTEGRA_SAIDA_CAD_PESSOA_STS@LNK_SAPORE_H9JULHO
             (CD_INTEGRA_SAIDA_CAD_PESSOA, TP_INTEGRACAO, DT_INTEGRACAO_MV2000, DS_EMPRESA_INTEGRACAO)
          VALUES(C_PACIENTE.CD_INTEGRA_SAIDA_CAD_PESSOA, 'T', SYSDATE, 'TEKNISA');
      END IF;

      IF v_QTCOMMIT = 500 THEN
         COMMIT;
         v_QTCOMMIT := 0;
      END IF;
      v_QTCOMMIT := v_QTCOMMIT + 1;

   END LOOP;

   COMMIT;

   v_QTCOMMIT := 0;

   /*VERIFICA CODIGO DA TABELA CID*/

   SELECT MAX(CDTABECDIPA)
     INTO V_CDTABECDIPA
     FROM PARAMGERAL
    WHERE (1 = 1);

   /*LOOP DE ATENDIMENTOS*/

   FOR C_ATENDIMENTO IN(
      SELECT INTATE.CD_INTEGRA_SAIDA_ATENDIMENTO,
             INTATE.CD_PACIENTE AS CD_PACIENTE,
             INTATE.CD_ATENDIMENTO AS CD_ATENDIMENTO,
             TO_DATE(TO_CHAR(INTATE.DT_ATENDIMENTO, 'DD/MM/YYYY') || TO_CHAR(INTATE.HR_ATENDIMENTO, 'HH24:MI:SS'), 'DD/MM/YYYY HH24:MI:SS') AS DT_ATENDIMENTO,
             INTATE.DT_INTEGRACAO_MV2000 AS DT_INTEGRACAO_MV2000,
             TO_DATE(TO_CHAR(INTATE.DT_ALTA, 'DD/MM/YYYY') || TO_CHAR(INTATE.HR_ALTA, 'HH24:MI:SS'), 'DD/MM/YYYY HH24:MI:SS') AS DT_ALTA,
             LPAD(INTATE.CD_CONVENIO, 3, '0') AS CD_CONVENIO,
             INTATE.SN_ALTA_POR_OBITO AS SN_ALTA_POR_OBITO,
             INTATE.CD_CID_ATENDIMENTO AS CD_CID_INT,
             INTATE.CD_LEITO AS CD_LEITO,
             INTATE.DS_LEITO
        FROM MVINTEGRA.INTEGRA_SAIDA_ATENDIMENTO@LNK_SAPORE_H9JULHO INTATE
       WHERE (INTATE.TP_ATENDIMENTO = 'I')
         AND (INTATE.TP_INTEGRACAO = 'A')
	 AND (INTATE.CD_LEITO IS NOT NULL)
         /*and (INTATE.TP_movimento = 'I')   */
         /*and trunc(INTATE.Dt_ATENDIMENTO) between to_date('010108','ddmmrr') and  to_date('311208','ddmmrr') */
         AND (INTATE.CD_INTEGRA_SAIDA_ATENDIMENTO > 4370000)
         AND NOT EXISTS(SELECT STATUS.CD_INTEGRA_SAIDA_ATENDIMENTO
                        FROM  MVINTEGRA.INTEGRA_SAIDA_ATENDIMENTO_STS@LNK_SAPORE_H9JULHO STATUS
                        WHERE (STATUS.DS_EMPRESA_INTEGRACAO = 'TEKNISA')
                          AND (INTATE.CD_INTEGRA_SAIDA_ATENDIMENTO = STATUS.CD_INTEGRA_SAIDA_ATENDIMENTO))
       )

   LOOP

      /*VERIFICAR SE J EXISTE O LEITO CADASTRADO*/

      SELECT MAX(CDLEITO)
         INTO V_EXIST
      FROM LEITO
      WHERE (CDFILIAL = V_CDFILIAL)
        AND (CDLEITO  = TO_CHAR(C_ATENDIMENTO.CD_LEITO));
      IF (V_EXIST IS NULL) THEN

         /*VERIFICAR SE J EXISTE O ANDAR CADASTRADO*/

         SELECT MAX(CDANDAR)
           INTO V_EXIST
         FROM ANDAR
         WHERE (CDFILIAL = V_CDFILIAL)
           AND (CDANDAR  = TO_CHAR(C_ATENDIMENTO.CD_LEITO));

         IF (V_EXIST IS NULL) THEN
            INSERT INTO ANDAR (CDFILIAL, CDANDAR, NMANDAR)
                       VALUES (V_CDFILIAL, TO_CHAR(C_ATENDIMENTO.CD_LEITO), TO_CHAR(C_ATENDIMENTO.CD_LEITO));
         END IF;

         /*VERIFICAR SE J EXISTE O ALA CADASTRADA*/

         SELECT MAX(CDALA)
            INTO V_EXIST
         FROM ALA
         WHERE (CDFILIAL = V_CDFILIAL)
           AND (CDALA    = TO_CHAR(C_ATENDIMENTO.CD_LEITO));
         IF (V_EXIST IS NULL) THEN
            INSERT INTO ALA (CDFILIAL, CDALA, NMALA)
                     VALUES (V_CDFILIAL, TO_CHAR(C_ATENDIMENTO.CD_LEITO), TO_CHAR(C_ATENDIMENTO.CD_LEITO));
         END IF;

         /*VEIFICAR SE EXISTE CADASTRADA A LIGAO DE ALA E ANDAR*/

         SELECT MAX(CDALA)
            INTO V_EXIST
         FROM ALANDAR
         WHERE (CDFILIAL = V_CDFILIAL)
           AND (CDALA    = TO_CHAR(C_ATENDIMENTO.CD_LEITO))
           AND (CDANDAR  = TO_CHAR(C_ATENDIMENTO.CD_LEITO));
         IF (V_EXIST IS NULL) THEN
            INSERT INTO ALANDAR (CDFILIAL, CDALA, CDANDAR)
                         VALUES (V_CDFILIAL, TO_CHAR(C_ATENDIMENTO.CD_LEITO), TO_CHAR(C_ATENDIMENTO.CD_LEITO));
         END IF;

         INSERT INTO LEITO (CDFILIAL, CDLEITO, NMLEITO, CDANDAR, CDALA)
                    VALUES (V_CDFILIAL, TO_CHAR(C_ATENDIMENTO.CD_LEITO), C_ATENDIMENTO.DS_LEITO,
                            TO_CHAR(C_ATENDIMENTO.CD_LEITO), TO_CHAR(C_ATENDIMENTO.CD_LEITO));
      END IF;

      /*VERIFICAR SE J EXISTE O PADRAO DE INTERNACAO CADASTRAD0*/

      SELECT MAX(CDSERPADDIE)
         INTO V_EXIST
      FROM PADRAOSERV
      WHERE (CDSERPADDIE = TO_CHAR(C_ATENDIMENTO.CD_CONVENIO));
      IF (V_EXIST IS NULL) THEN
         INSERT INTO PADRAOSERV (CDSERPADDIE, NMSERPADDIE)
                         VALUES (TO_CHAR(C_ATENDIMENTO.CD_CONVENIO), TO_CHAR(C_ATENDIMENTO.CD_CONVENIO));
      END IF;

      /*VERIFICAR A TROCA DE LEITO*/

      SELECT MAX(CDLEITO)
         INTO V_CDLEITO
      FROM INTERNAC
      WHERE (CDFILIAL = V_CDFILIAL)
        AND (CDPACIENTE = TO_CHAR(C_ATENDIMENTO.CD_PACIENTE))
        AND (DTINTERNA = C_ATENDIMENTO.DT_ATENDIMENTO);

      IF (V_CDLEITO IS NULL) THEN
         INSERT INTO INTERNAC (CDFILIAL, CDPACIENTE, DTINTERNA, DTALTA, CDSERPADDIE, CDLEITO)
                       VALUES (V_CDFILIAL, TO_CHAR(C_ATENDIMENTO.CD_PACIENTE), C_ATENDIMENTO.DT_ATENDIMENTO,
                               C_ATENDIMENTO.DT_ALTA, TO_CHAR(C_ATENDIMENTO.CD_CONVENIO), TO_CHAR(C_ATENDIMENTO.CD_LEITO));

      ELSE

         IF (V_CDLEITO <> C_ATENDIMENTO.CD_LEITO) THEN
            UPDATE INTERNAC
               SET CDLEITO = TO_CHAR(C_ATENDIMENTO.CD_LEITO)
             WHERE (CDFILIAL = V_CDFILIAL)
               AND (CDPACIENTE = TO_CHAR(C_ATENDIMENTO.CD_PACIENTE))
               AND (DTINTERNA = C_ATENDIMENTO.DT_ATENDIMENTO);
         END IF;

      END IF;

      /*VERIFICA O DIAGNOSTICO DO PACIENTE*/


      SELECT MAX(CDDIAGNOST)
          INTO V_CDDIAGNOST
      FROM DIAGNOST
      WHERE (CDTABECDI = V_CDTABECDIPA)
        AND (CDDIAGNOST = C_ATENDIMENTO.CD_CID_INT);

      IF (NOT V_CDDIAGNOST IS NULL) THEN

         SELECT MAX(CDDIAGNOST)
            INTO V_CDDIAGNOST
         FROM DIAGINTER
         WHERE (CDFILIAL = V_CDFILIAL)
           AND (CDPACIENTE = TO_CHAR(C_ATENDIMENTO.CD_PACIENTE))
           AND (DTINTERNA = C_ATENDIMENTO.DT_ATENDIMENTO)
           AND (CDDIAGNOST = C_ATENDIMENTO.CD_CID_INT);

         IF (V_CDDIAGNOST IS NULL) THEN
            INSERT INTO DIAGINTER (CDPACIENTE, DTINTERNA, CDDIAGNOST, CDTABECDI, CDFILIAL)
                           VALUES (TO_CHAR(C_ATENDIMENTO.CD_PACIENTE),
                                   C_ATENDIMENTO.DT_ATENDIMENTO,
                                   C_ATENDIMENTO.CD_CID_INT,
                                   V_CDTABECDIPA,
                                   V_CDFILIAL);

         END IF;
      END IF;

      IF (NOT C_ATENDIMENTO.DT_ALTA IS NULL) THEN
         UPDATE INTERNAC
           SET DTALTA  = C_ATENDIMENTO.DT_ALTA,
               IDMOTIALTA = DECODE(C_ATENDIMENTO.SN_ALTA_POR_OBITO, 'S', '1', '0')
         WHERE (CDFILIAL = V_CDFILIAL)
           AND (CDPACIENTE = TO_CHAR(C_ATENDIMENTO.CD_PACIENTE))
           AND (DTINTERNA  = C_ATENDIMENTO.DT_ATENDIMENTO);
      END IF;

      IF (V_CDLEITO <> C_ATENDIMENTO.CD_LEITO) THEN
         /*DESOCUPA O LEITO ANTERIOR*/
         UPDATE LEITO
            SET IDOCUPLEITO = V_CONST_N
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDLEITO = V_CDLEITO);

         UPDATE LEITO
            SET IDOCUPLEITO = V_CONST_S
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDLEITO  = TO_CHAR(C_ATENDIMENTO.CD_LEITO));
      END IF;

      INSERT INTO MVINTEGRA.INTEGRA_SAIDA_ATENDIMENTO_STS@LNK_SAPORE_H9JULHO
        (CD_INTEGRA_SAIDA_ATENDIMENTO, DS_EMPRESA_INTEGRACAO, DT_INTEGRACAO_MV2000, TP_INTEGRACAO)
      VALUES (C_ATENDIMENTO.CD_INTEGRA_SAIDA_ATENDIMENTO, 'TEKNISA', SYSDATE, 'T');

      IF v_QTCOMMIT = 5000 THEN
         COMMIT;
         v_QTCOMMIT := 0;
      END IF;
      v_QTCOMMIT := v_QTCOMMIT + 1;


   END LOOP;

   COMMIT;

   v_QTCOMMIT := 0;

   /*LOOP DE NUTRICAO*/
   FOR C_NUTRICAO IN(
      SELECT LPAD(NUTRI.CD_TIPO_REFEICAO, 4, '0') AS CD_TIPO_REFEICAO,
             NUTRI.CD_PACIENTE,
             NUTRI.CD_ATENDIMENTO
        FROM MVINTEGRA.INTEGRA_SAIDA_NUTRICAO@LNK_SAPORE_H9JULHO NUTRI
       WHERE  (NUTRI.TP_INTEGRACAO = 'A'))

   LOOP

      SELECT MAX(CDDIETPAD)
        INTO V_CDDIETPAD
      FROM DIETPADR
      WHERE (DIETPADR.CDDIETPAD  = C_NUTRICAO.CD_TIPO_REFEICAO)
        AND (DIETPADR.IDFORMDIET = '0');

      IF (NOT V_CDDIETPAD IS NULL) THEN
        BEGIN
         SELECT DTALTA, CDLEITO
           INTO V_DTALTA, V_CDLEITO
           FROM INTERNAC
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDPACIENTE = TO_CHAR(C_NUTRICAO.CD_PACIENTE))
            AND (DTINTERNA = (SELECT MAX(DTINTERNA)
                                FROM INTERNAC
                               WHERE CDFILIAL = V_CDFILIAL
                                 AND CDPACIENTE = TO_CHAR(C_NUTRICAO.CD_PACIENTE)));

         EXCEPTION
           WHEN NO_DATA_FOUND THEN
               V_DTALTA := NULL;
               V_CDLEITO := NULL;
           END;
         IF (V_DTALTA IS NULL) AND (NOT V_CDLEITO IS NULL) THEN

            /*GERAR NOVA PRESCRIO PARA PACIENTE*/

            V_SYSDATE := SYSDATE;

            SELECT MAX(P.DTPRESDIET)
              INTO V_DTPRESDIET
              FROM PRESDIET P
             WHERE (P.CDFILIAL = V_CDFILIAL)
               AND (P.CDPACIENTE = TO_CHAR(C_NUTRICAO.CD_PACIENTE))
               AND (P.DTPRESDIET = V_SYSDATE);

            IF (V_DTPRESDIET IS NULL) THEN

               INSERT INTO PRESDIET (CDFILIAL, CDPACIENTE, DTPRESDIET, CDDIETPAD, CDLEITO)
                             VALUES (V_CDFILIAL, TO_CHAR(C_NUTRICAO.CD_PACIENTE),
                                     V_SYSDATE, TO_CHAR(C_NUTRICAO.CD_TIPO_REFEICAO), V_CDLEITO);

           end if;
        END IF;

      END IF;

      IF v_QTCOMMIT = 500 THEN
         COMMIT;
         v_QTCOMMIT := 0;
      END IF;

      v_QTCOMMIT := v_QTCOMMIT + 1;

   END LOOP;

   COMMIT;

  /* UPDATE MVINTEGRA.INTEGRA_SAIDA_NUTRICAO@LNK_SAPORE_H9JULHO
      SET TP_INTEGRACAO = 'T',
          DT_INTEGRACAO_MV2000 = SYSDATE
   WHERE (TP_INTEGRACAO = 'A'); */

END;
/


-- VERSAO --
BEGIN ATUVEROBJ('INTEGRACAO_PACIENTE','5.05.022'); END;
/
