var Cmp05300AFPorFilialController = function(ScreenService, General, Parametros, restEngine, templateManager, MessageService) {
	
	this.widgetOnEnter = function(widget){
		/* ProjectCorp true é Matriz, do contrário, Filial.
		Na query, o MODO 'N' equivale a Matriz, e Filial 'S'. */
		//widget.currentRow.MODO = window.projectCorp ? 'N' : 'S';
		widget.currentRow.MODO = 'N';
		
		this.atualizaFiltroAutorizacaoFornecimento();
	}; 

	this.limpaFieldsAutorizacaoFornecimento = function(widget) {
		widget.getField("NRAUTOFORNINI").clearValue();
		widget.getField("NRAUTOFORNFIN").clearValue();
	};
	

	this.toggleDataEntrega = function(field) {
		var widget = field.getParent(),
			secondFieldAutoForn = field.name === 'NRAUTOFORNINI' ? widget.getField('NRAUTOFORNFIN') : widget.getField('NRAUTOFORNINI'),
			fieldDataEntrega = widget.getField('DT_INTERVAL'),
			isReadOnly = fieldDataEntrega.readOnly;
			
		if (widget.currentRow[field.name] || widget.currentRow[secondFieldAutoForn.name]) {
			if (!isReadOnly) {
				fieldDataEntrega.readOnly = true;
				fieldDataEntrega.clearValue();
				fieldDataEntrega.validations = {};
			}
		} else if (isReadOnly) {
			fieldDataEntrega.readOnly = false;
			fieldDataEntrega.validations = {requiredInterval: true};
		}
		
		//this.limparMensagemCampoObrigatorio(widget);
	};
	
	this.toggleAutorizacaoFornecimento = function(fieldDataEntrega) {
	
		var widget = fieldDataEntrega.getParent(),
			fieldsAutoForn = [
				widget.getField('NRAUTOFORNINI'),
				widget.getField('NRAUTOFORNFIN')
			],
			isReadOnly = widget.getField('NRAUTOFORNINI').readOnly;
			
		var valida = widget.currentRow[fieldDataEntrega.name].start && widget.currentRow[fieldDataEntrega.name].end;	
		if (valida) {
			if (!isReadOnly) {
				fieldsAutoForn.forEach(function(field) {
					field.readOnly = true;
					field.clearValue();
					field.validations = {};
				});
			}
		} else if (isReadOnly) {
			fieldsAutoForn.forEach(function(field) {
				field.readOnly = false;
				field.validations = {required: true};
			});
		}
		
		this.limparMensagemCampoObrigatorio(widget);
	};

	this.concatArray = function(value, defaultValue = 'T') {
	    if (!Util.isEmptyOrBlank(value)) {
	        return Array.isArray(value) ? value.join('_') : value;
	    }
	
	    return defaultValue;
	};
	
	this.atualizaFiltroAutorizacaoFornecimento = function() {
		const widget = templateManager.container.getWidget('cmp05300');
		let currentRow = widget.currentRow;
		
		let params = {
				"NRORG": getLocalVar('NRORG'),
				"MODO": currentRow.MODO,
				"CDFILDEST": this.concatArray(currentRow.CDFILDEST),
				"CDFILLANC": this.concatArray(currentRow.CDFILLANC),
				"CDOPERADOR": this.concatArray(currentRow.NMOPERADOR)
            };
		let fields = ["NRAUTOFORNINI", "NRAUTOFORNFIN"];
		fields.forEach(function(fieldName){
			widget.getField(fieldName).dataSourceFilter.forEach(function(filter){
				if (params[filter.name])
					filter.value = params[filter.name];
			});
		});
	};
	
	this.atualizaFiltroUnidade = function() {
		const widget = templateManager.container.getWidget('cmp05300');
		let currentRow = widget.currentRow;
		
		let params = {
				"P_NRORG": getLocalVar('NRORG'),
				"P_CDOPERADOR": getLocalVar('CDOPERADOR'),
				"P_CDREGIAO": this.concatArray(currentRow.CDREGIAO)
            };
		let fields = ["CDFILDEST", "CDFILLANC"];
		fields.forEach(function(fieldName){
			widget.getField(fieldName).dataSourceFilter.forEach(function(filter){
				filter.value = params[filter.name];
			});
		});
		
		widget.getField("CDFILDEST").reload();
		widget.getField("CDFILLANC").reload();
	};

	this.validaNumeroAF = function(currentRow) {
		var autoIni = currentRow.NRAUTOFORNINI;
		var autoFin = currentRow.NRAUTOFORNFIN;

		if (autoIni && autoFin && autoIni > autoFin ) {
			MessageService.showMessageByCode("AUTORIZACAO_AF_MENOR_IGUAL");
			return false;
		} else if(!autoIni && !autoFin) {
			return false;
		}
		
		return true;
	};
	
	this.montaParametrosRelatorio = function(currentRow) {
        var currentRowCopy = angular.copy(currentRow),
	        params = {
	            'QR2TYPE': currentRowCopy.QR2TYPE,
	            'REPORT_NAME': currentRowCopy.REPORT_NAME,
	            'CDREGIAO': this.concatArray(currentRowCopy.CDREGIAO),
				'FILLANC': this.concatArray(currentRowCopy.CDFILLANC),
				'CDFILDEST': this.concatArray(currentRowCopy.CDFILDEST),
				'OPERADOR': this.concatArray(currentRowCopy.NMOPERADOR),
				'IMPOSTO': this.concatArray(currentRowCopy.SGIMPOSTO),
				'CDFORNECED': this.concatArray(currentRowCopy.CDFORNECED),
				'ORDENA': currentRowCopy.ORDENA,
				'MODO': currentRowCopy.MODO,
				'NRAUTOFORNINI': currentRowCopy.NRAUTOFORNINI,
				'NRAUTOFORNFIN': currentRowCopy.NRAUTOFORNFIN,
				'IMPRIME': currentRowCopy.IMPRIME,
				'AFORDT': currentRowCopy.AFORDT,
				'IMPRIMEOBS': currentRowCopy.IMPRIMEOBS,
				'CDFILIPROC': currentRowCopy.CDFILIPROC
	        };
        
        params.CDREGIAO1 = params.CDREGIAO;
		params.CDREGIAO2 = params.CDREGIAO;
		
        if (currentRowCopy.DT_INTERVAL) {
			params.DTENTREINI = currentRowCopy.DT_INTERVAL.start;
			params.DTENTREFIN = currentRowCopy.DT_INTERVAL.end;
		} else {
			params.DTENTREINI = '';
			params.DTENTREFIN = '';
		}
        
        return params;
    };
	
	this.validacaoCampos = function(widget) {
		const reportFormat = [
            {
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xls",
				value: "XLSX"
			},
			{
				name: "txt",
				value: "TXT"
			}   
        ];
		
		
		if(widget.isValid()) {
			var consideraAF = !widget.getField('NRAUTOFORNINI').isReadOnly(),
				currentRow = widget.currentRow,
				reportName = currentRow.REPORT_NAME;
				
			if (consideraAF) {
				if (!this.validaNumeroAF(currentRow)) {
					return;
				}
				
				currentRow.AFORDT = 1;
			} else {
				currentRow.AFORDT = 2;
			}

			General.openReportPopup(
				widget,
				this.abreRelatorio,
				[widget, reportName],
				reportFormat);
		}
	};
	
	this.abreRelatorio = function(widget, reportName) {
		var paramsReport = this.montaParametrosRelatorio(widget.currentRow);
		General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp05300_af_por_filial', reportName, paramsReport);
	}.bind(this);
	
	/**
	 * Utilizado para limpar as mensagems de 'Campo Obrigatório' dos fields:
	 * - 'Inicial' e 'Final' do grupo 'Autorização de Fornecimento';
	 * - 'Data de Entrega'.
	 * 
	 * @params widget
	 */
	this.limparMensagemCampoObrigatorio = function(widget) {
		var fields = [
			'NRAUTOFORNINI',
			'NRAUTOFORNFIN',
			'DT_INTERVAL'
			];
		
			
		fields.forEach(function(field) {
			if (widget.currentRow.$error[field]) {
			   delete widget.currentRow.$error[field];
			}
			//delete widget.getField(field).validations;
		});
		
	};
	
	this.onChangeDataEntrega = function(field) {
		this.toggleAutorizacaoFornecimento(field);
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cmp05300AFPorFilialController', Cmp05300AFPorFilialController);
});